% Autogenerated with DRAKON Editor 1.20

-module(erldemo).
-export([fibonacci/1, foreach/2, main/0, quicksort/2]).

back_cmp(X, Y) ->
    % item 168
    if X < Y -> 
        % item 169
        1
    ; true ->
        % item 173
        if X > Y -> 
            % item 174
            -1
        ; true ->
            % item 175
            0
        end
    end
.

fibonacci(N) ->
    % item 2100001
    if N =:= 0 -> 
        % item 218
        {0}
    ; true ->
        % item 2100002
        if N =:= 1 -> 
            % item 219
            {0, 1}
        ; true ->
            % item 220
            Previous = fibonacci(N - 1),
            % item 221
            F2 = element(N - 1, Previous),
            F1 = element(N, Previous),
            Fib = F2 + F1,
            % item 222
            erlang:append_element(
            	Previous, 
            	Fib
            )
        end
    end
.

foreach(List, Visitor) ->
    % item 55
    if List == [] -> 
        % item 56
        void
    ; true ->
        % item 59
        [ Head | Rest ] = List,
        Visitor(Head),
        % item 60
        foreach(Rest, Visitor)
    end
.

foreach_demo() ->
    % item 49
    io:format("iteration demo~n"),
    % item 42
    FibonacciTuple = fibonacci(20),
    Fibonacci = tuple_to_list(FibonacciTuple),
    % item 224
    Visitor = fun(X) -> 
    	print(X)
    end,
    % item 61
    foreach(Fibonacci, Visitor),
    io:format("~n", [])
.

is_sorted(List) ->
    % item 182
    Length = length(List),
    % item 1830001
    if (Length =:= 0) orelse (Length =:= 1) -> 
        []
    ; true ->
        % item 191
        [First, Second | Tail] = List,
        % item 192
        Cmp = back_cmp(First, Second),
        % item 193
        if Cmp == 1 -> 
            % item 195
            print_list(List),
            throw("List not sorted")
        ; true ->
            % item 196
            is_sorted(Tail)
        end
    end
.

main() ->
    % item 34
    foreach_demo(),
    % item 66
    quicksort_demo()
.

print(Item) ->
    % item 48
    io:format("~w ", [Item])
.

print_list(List) ->
    % item 226
    Visitor = fun(X) -> 
    	io:format("~s ", [X]) 
    end,
    % item 225
    foreach(List, Visitor),
    % item 75
    io:format("~n", [])
.

quicksort(List, Comparer) ->
    % item 121
    Length = length(List),
    % item 1220001
    if (Length =:= 0) orelse (Length =:= 1) -> 
        % item 157
        Result = List
    ; true ->
        % item 1220003
        if Length =:= 2 -> 
            % item 158
            [ First, Second | _ ] = List,
            Cmp = Comparer(First, Second),
            % item 159
            if Cmp == -1 -> 
                % item 160
                Result = List
            ; true ->
                % item 138
                Result = [Second, First]
            end
        ; true ->
            % item 141
            [ Pivot | Others ] = List,
            % item 223
            LessThanPivot = fun(X) ->
            	Comparer(X, Pivot) == -1 
            end,
            % item 198
            {Left, Right} = lists:partition(
            	LessThanPivot,
            	Others
            ),
            % item 155
            LeftSorted = quicksort(Left, Comparer),
            RightSorted = quicksort(Right, Comparer),
            % item 161
            Result = LeftSorted ++ [Pivot] ++ RightSorted
        end
    end,
    % item 162
    Result
.

quicksort_demo() ->
    % item 65
    io:format("quick sort demo~n", []),
    % item 67
    Unsorted = [ "the", "sooner", "we", "start", "this", "the", "better" ],
    Sorted   = [ "aa", "bb", "cc", "dd", "ee", "ff" ],
    Reverse  = [ "ff", "ee", "dd", "cc", "bb", "aa" ],
    Empty    = [],
    Flat     = [ "flat", "flat", "flat", "flat", "flat" ],
    % item 91
    Comparer = fun(X, Y) -> back_cmp(X, Y) end,
    Unsorted2 = quicksort(Unsorted, Comparer),
    Sorted2 = quicksort(Sorted, Comparer),
    Reverse2 = quicksort(Reverse, Comparer),
    Empty2 = quicksort(Empty, Comparer),
    Flat2 = quicksort(Flat, Comparer),
    % item 68
    print_list(Unsorted2),
    print_list(Sorted2),
    print_list(Reverse2),
    print_list(Empty2),
    print_list(Flat2),
    % item 197
    is_sorted(Unsorted2),
    is_sorted(Sorted2),
    is_sorted(Reverse2),
    is_sorted(Empty2),
    is_sorted(Flat2)
.


